# This is for Rails

#require 'rails_generator'
#require 'rails_generator/base'
#require 'railties/lib/rails_generator/base'

DB_PROJECT_ROOT = RAILS_ROOT
require File.join( File.expand_path(File.dirname(__FILE__)),'','migration_generator_core' )

class MigrationGenerator < Rails::Generator::Base

  def initialize(runtime_args, runtime_options = {})
    super
    @migration_arg_name = runtime_args.first
  end

  def manifest
    mg = MigrationGeneratorCore.new
    up,down,hints,migration_name = mg.calculate_migration( @migration_arg_name )

    record do |m|
      m.migration_template 'migration.rb', 'db/migrate', 
                           :assigns => { :up => up, :down => down, :hints => hints, :migration_name => migration_name.camelize }, 
                           :migration_file_name => migration_name
      end
  end
  
end
