# This is for Sinatra

require 'active_record'
require 'active_support/core_ext/string/strip'
require 'fileutils'

DB_PROJECT_ROOT = "."
require File.join( File.expand_path(File.dirname(__FILE__)),'migration_generator_core' )

module Sinatra
  module ActiveRecordTasks
    extend self

    def create_migration(migration_name, version = nil)

      mg = MigrationGeneratorCore.new
      up,down,hints,migration_name = mg.calculate_migration( migration_name )

      migration_number = Time.now.utc.strftime("%Y%m%d%H%M%S")
      migration_file = File.join(migrations_dir, "#{migration_number}_#{migration_name}.rb")

      FileUtils.mkdir_p(migrations_dir)

      File.open(migration_file, 'w') do |file|
        file.write <<-MIGRATION.strip_heredoc
class #{ migration_name.camelize } < ActiveRecord::Migration
  def self.up
#{ up }
  end

  def self.down
#{ down }
  end
end

#{ hints }
MIGRATION
      end

      # puts "done"

    end

  end

end

# no need to load because already loaded from sinatra_activerecord
# load 'sinatra/activerecord/tasks.rake'